import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.util.Diagnostician;
import org.eclipse.emf.ecore.xmi.impl.EcoreResourceFactoryImpl;

import root.RootFactory;
import root.Test;

public class TestOCLValidation {

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		initEMF();

		Test test = RootFactory.eINSTANCE.createTest();
		test.setAtt1(1);
		test.setAtt2(123);

		// OCL constraint is self.att1 > self.att2
		// The validation of this instance must raise a validation error

		Diagnostic diag = Diagnostician.INSTANCE.validate(test);
		for (Diagnostic subDiag : diag.getChildren()) {
			System.out.println(subDiag);
		}

	}

	private static void initEMF() {
		Resource.Factory.Registry.INSTANCE.getExtensionToFactoryMap().put("ecore",
				new EcoreResourceFactoryImpl());

		// org.eclipse.ocl.ecore.OCL.initialize(null);
		org.eclipse.ocl.ecore.delegate.OCLDelegateDomain.initialize(null);
		org.eclipse.ocl.examples.pivot.model.OCLstdlib.install();
		org.eclipse.ocl.examples.pivot.delegate.OCLDelegateDomain.initialize(null);
	}

}
